import { Logger as BaseLogger } from 'winston';
declare type Logger = {
    err: (message: string) => void;
    info: (message: string) => void;
    dbg: (message: string) => void;
    logger: BaseLogger;
};
declare const loggerLevelsInfo: {
    levels: {
        err: number;
        info: number;
        dbg: number;
    };
    colors: {
        err: string;
        info: string;
        dbg: string;
    };
};
declare type LoggerLevelsInfo = typeof loggerLevelsInfo;
declare type LoggerLevels = keyof LoggerLevelsInfo['levels'];
export declare function initLogger(level: LoggerLevels): void;
export declare function getLogger(): Logger;
export {};
