"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fileExists = fileExists;
exports.readFile = readFile;
exports.saveFile = saveFile;

var _constants = require("constants");

var _fs = _interopRequireDefault(require("fs"));

var _path = require("path");

function fileExists(path) {
  try {
    _fs["default"].accessSync(path, _constants.F_OK);

    return true;
  } catch (e) {
    return false;
  }
}

function saveFile(path, data) {
  var dir = (0, _path.dirname)(path);

  if (dir !== '') {
    _fs["default"].mkdirSync(dir, {
      recursive: true
    });
  }

  _fs["default"].writeFileSync(path, data); // eslint-disable-next-line


  console.log("Saved: ".concat(path));
}

function readFile(path) {
  return _fs["default"].readFileSync(path).toString();
}
//# sourceMappingURL=file.service.js.map